drew.fg.proxy = function() {
  var proxy = {};
  proxy.parse = function(url) {
    var tmp_split;
    var proxy_host;
    var auth;
    tmp_split = url.split("://");
    var typeproxy = tmp_split[0].toUpperCase();
    if (typeproxy === "HTTP") {
      typeproxy = "PROXY";
    }
    tmp_split = tmp_split[1].split("@");
    if (tmp_split.length > 1) {
      proxy_host = tmp_split[1];
      var tmp_auth = tmp_split[0].split(":");
      drew.fg.auth[proxy_host] = {l:tmp_auth[0], p:tmp_auth[1]};
      auth = tmp_split[0];
    } else {
      proxy_host = tmp_split[0];
    }
    tmp_split = proxy_host.split(":");
    return {"typepoxy":typeproxy, "proxy_host":tmp_split[0], "port":tmp_split[1], "auth":auth};
  };
  proxy.set = function(start) {
    var on = drew.fg.ls.get("on");
    var mode = drew.fg.ls.get("mode");
    var mode2 = drew.fg.ls.get("mode2");
    var endfunction = function() {
    };
    var proxy = drew.fg.ls.get("proxy");
    drew.fg.auth = {};
    if (on && proxy) {
      var dis_country = drew.fg.ls.get("dis_country"), dis_country_len = 0;
      var prior_country = drew.fg.ls.get("prior_country"), prior_country_len = 0;
      var proxy_str = {};
      var p_prior = "";
      var p_others = "";
      if (typeof dis_country === "object" && dis_country) {
        dis_country_len = dis_country.length;
      }
      if (typeof prior_country === "object" && prior_country) {
        prior_country_len = prior_country.length;
      }
      var i;
      var start_co = [];
      while (i = proxy.shift()) {
        var proxy_unparse = drew.fg.proxy.parse(i.h);
        var proxy_host = proxy_unparse.proxy_host + ":" + proxy_unparse.port;
        var typeproxy = proxy_unparse.typepoxy;
        if (!proxy_str.hasOwnProperty(i.co)) {
          proxy_str[i.co] = "";
        }
        proxy_str[i.co] = proxy_str[i.co] + typeproxy + " " + proxy_host + "; ";
        if (dis_country_len > 0 && drew.fg.lib.Array_contains(i.co, dis_country)) {
          continue;
        }
        if (prior_country_len > 0 && drew.fg.lib.Array_contains(i.co, prior_country)) {
          if (start_co.length > 0) {
            start_co = [];
          }
          start_co.push(i.co);
          p_prior = p_prior + typeproxy + " " + proxy_host + "; ";
        } else {
          start_co.push(i.co);
          p_others = p_others + typeproxy + " " + proxy_host + "; ";
        }
      }
      proxy_str.p = p_prior + p_others;
      if (proxy_str.p === "") {
        return false;
      }
      var src = "function FindProxyForURL(url, host) {" + "var schema=url.substring(0,5); " + "if ( schema!='https' && schema!='http:' ) return 'DIRECT';";
      var api_list = drew.fg.ls.get("fp2");
      if (typeof api_list === "object" && api_list && api_list.length > 0) {
        api_list = api_list.map(function(h) {
          return h + ":80/";
        });
        drew.fg.lib.debug(0, api_list);
        src = src + "var sites_api = " + JSON.stringify(api_list) + "; " + "var i;" + "while (i = sites_api.shift()) { " + "if (shExpMatch(url,i)) return 'DIRECT';" + "}";
      }
      var sites_exception = drew.fg.ls.get("sites_exception");
      var sites_exception_list = "";
      if (typeof sites_exception === "object" && sites_exception && sites_exception.length > 0) {
        sites_exception_list = JSON.stringify(sites_exception);
        src = src + "var sites_exception = " + sites_exception_list + "; " + "var i;" + "while (i = sites_exception.shift()) { " + "if ((('*.'+host)==i)||shExpMatch(host,i)) return 'DIRECT';" + "}";
      }
      var sites_proxy = drew.fg.ls.get("sites");
      var sites_proxy_list = {any:{s:[], p:proxy_str.p}};
      if (typeof sites_proxy === "object" && sites_proxy && sites_proxy.length > 0) {
        var i$0;
        while (i$0 = sites_proxy.shift()) {
          if (!i$0.hasOwnProperty("h")) {
            continue;
          }
          var co = "any";
          if (i$0.hasOwnProperty("co") && i$0.co.length > 0) {
            co = i$0.co.join();
            if (!sites_proxy_list.hasOwnProperty(co)) {
              sites_proxy_list[co] = {s:[], p:""};
            }
            var j = undefined;
            var tmp_proxy = "";
            while (j = i$0.co.shift()) {
              if (proxy_str.hasOwnProperty(j)) {
                tmp_proxy = tmp_proxy + proxy_str[j];
              }
            }
            if (tmp_proxy != "") {
              sites_proxy_list[co].p = tmp_proxy;
            } else {
              if (mode2) {
                sites_proxy_list[co].p = proxy_str.p;
              } else {
                sites_proxy_list[co].p = "PROXY localhost:0";
              }
            }
          }
          sites_proxy_list[co].s.push(i$0.h);
        }
        for (var location in sites_proxy_list) {
          if (!sites_proxy_list.hasOwnProperty(location)) {
            continue;
          }
          if (typeof sites_proxy_list[location].s === "object" && sites_proxy_list[location].s.length > 0 && typeof sites_proxy_list[location].p === "string" && sites_proxy_list[location].p !== "") {
            var sites_list = JSON.stringify(sites_proxy_list[location].s);
            src = src + "var sites = " + sites_list + "; " + "var i;" + "while (i = sites.shift()) { " + "if ((('*.'+host)==i)||shExpMatch(host,i)) return '" + sites_proxy_list[location].p + "';" + "}";
          }
        }
        if (drew.fg.bl.enabled && Object.keys(drew.fg.bl.list).length > 0) {
          var bl_sites_list = JSON.stringify(drew.fg.bl.list);
          src = src + "var sites = " + bl_sites_list + "; " + "if (host in sites) return '" + sites_proxy_list["any"].p + "';" + "var hostSplitDot = host.split('.');" + "var hostSplitDotLength = hostSplitDot.length;" + "if (hostSplitDotLength > 2) {" + "var subdomain = hostSplitDot[hostSplitDotLength - 1];" + "for (var i = hostSplitDotLength - 2; i > 0; i--) {" + "subdomain = hostSplitDot[i] + '.' + subdomain;" + "if (subdomain in sites) return '" + sites_proxy_list["any"].p + "';" + "}}";
        }
      }
      if (mode === 2) {
        src = src + " return 'DIRECT';" + "}";
      } else {
        if (mode === 3) {
          src = src + " return '" + proxy_str.p + "';" + " return 'DIRECT';}";
        } else {
          src = src + " return 'DIRECT';" + "}";
        }
      }
      drew.fg.lib.debug(1, src);
      var old_md5 = drew.fg.ls.get("md5.pr");
      var new_md5 = md5(src);
      if (!start && old_md5 == new_md5) {
        return;
      }
      if (start_co.length > 0) {
        drew.fg.ls.set("start_co", start_co[0]);
      }
      drew.fg.ls.set("md5.pr", new_md5);
      var config = {mode:"pac_script", pacScript:{data:src}};
      try {
        chrome.proxy.settings.set({value:config, scope:"regular"}, endfunction);
      } catch (e) {
        endfunction();
      }
    } else {
      chrome.proxy.settings.clear({scope:"regular"}, function() {
      });
    }
  };
  return proxy;
}();

